/*
 * Copyright (C) by
 *   MetraLabs GmbH (MLAB), GERMANY
 * and
 *   Neuroinformatics and Cognitive Robotics Labs (NICR) at TU Ilmenau, GERMANY
 * All rights reserved.
 *
 * Contact: info@mira-project.org
 *
 * Commercial Usage:
 *   Licensees holding valid commercial licenses may use this file in
 *   accordance with the commercial license agreement provided with the
 *   software or, alternatively, in accordance with the terms contained in
 *   a written agreement between you and MLAB or NICR.
 *
 * GNU General Public License Usage:
 *   Alternatively, this file may be used under the terms of the GNU
 *   General Public License version 3.0 as published by the Free Software
 *   Foundation and appearing in the file LICENSE.GPL3 included in the
 *   packaging of this file. Please review the following information to
 *   ensure the GNU General Public License version 3.0 requirements will be
 *   met: http://www.gnu.org/copyleft/gpl.html.
 *   Alternatively you may (at your option) use any later version of the GNU
 *   General Public License if such license has been publicly approved by
 *   MLAB and NICR (or its successors, if any).
 *
 * IN NO EVENT SHALL "MLAB" OR "NICR" BE LIABLE TO ANY PARTY FOR DIRECT,
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
 * THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF "MLAB" OR
 * "NICR" HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * "MLAB" AND "NICR" SPECIFICALLY DISCLAIM ANY WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND "MLAB" AND "NICR" HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS.
 */

/**
 * @file Bind.h
 *    Wrapper for boost/bind
 *
 * @author Christof Schröter
 * @date   2021/08/05
 */

#ifndef _MIRA_BIND_H_
#define _MIRA_BIND_H_

#include <boost/version.hpp>

#if BOOST_VERSION <= 107100

#ifndef Q_MOC_RUN
#include <boost/bind.hpp>
#endif

#else // BOOST_VERSION > 107100

#ifndef Q_MOC_RUN
#include <boost/bind/bind.hpp>
#endif

namespace mira {
inline namespace placeholders {
// inline namespace keeps members visible in namespace mira,
// but allows to explicitly only make accessible names in mira::placeholders (from outside mira)

///////////////////////////////////////////////////////////////////////////////

#ifndef BOOST_BIND_NO_PLACEHOLDERS

using boost::placeholders::_1;
using boost::placeholders::_2;
using boost::placeholders::_3;
using boost::placeholders::_4;
using boost::placeholders::_5;
using boost::placeholders::_6;
using boost::placeholders::_7;
using boost::placeholders::_8;
using boost::placeholders::_9;

#else

#pragma message("BOOST_BIND_NO_PLACEHOLDERS is defined - boost provides no placeholders")

#endif // BOOST_BIND_NO_PLACEHOLDERS

///////////////////////////////////////////////////////////////////////////////

}}

#endif // BOOST_VERSION

#endif
